diff --git a/app/models/host.rb b/app/models/host.rb
index 9c74f29..c538bf5 100644
--- a/app/models/host.rb
+++ b/app/models/host.rb
@@ -1,4 +1,5 @@
 class Host < Puppet::Rails::Host
+  include Authorization
   belongs_to :architecture
   belongs_to :media
   belongs_to :model
@@ -52,6 +53,34 @@ class Host < Puppet::Rails::Host
   named_scope :successful, {:conditions => "puppet_status = 0"}
   named_scope :alerts_disabled, {:conditions => ["enabled = ?", false] }
 
+  named_scope :my_hosts, lambda {
+    user                 = User.current
+    owner_conditions     = sanitize_sql_for_conditions(["((hosts.owner_id in (?) AND hosts.owner_type = 'Usergroup') OR (hosts.owner_id = ? AND hosts.owner_type = 'User'))", user.my_usergroups.map(&:id), user.id])
+    domain_conditions    = sanitize_sql_for_conditions([" (hosts.domain_id in (?))",dms = (user.domains).map(&:id)])
+    hostgroup_conditions = sanitize_sql_for_conditions([" (hosts.hostgroup_id in (?))",(hgs = user.hostgroups).map(&:id)])
+
+    fact_conditions = ""
+    for user_fact in (ufs = user.user_facts)
+      fact_conditions += sanitize_sql_for_conditions ["(hosts.id = fact_values.host_id and fact_values.fact_name_id = ? and fact_values.value #{user_fact.operator} ?)", user_fact.fact_name_id, user_fact.criteria]
+      fact_conditions = user_fact.andor == "and" ? "(#{fact_conditions}) and " : "#{fact_conditions} or  "
+    end
+    if match = fact_conditions.match(/^(.*).....$/)
+      fact_conditions = "(#{match[1]})"
+    end
+
+    conditions = ""
+    if user.filtering?
+      conditions  = "#{owner_conditions}"                                                                                                            if     user.filter_on_owner
+      (conditions = (user.domains_andor    == "and") ? "(#{conditions}) and #{domain_conditions} "    : "#{conditions} or #{domain_conditions} ")    unless dms.empty?
+      (conditions = (user.hostgroups_andor == "and") ? "(#{conditions}) and #{hostgroup_conditions} " : "#{conditions} or #{hostgroup_conditions} ") unless hgs.empty?
+      (conditions = (user.facts_andor      == "and") ? "(#{conditions}) and #{fact_conditions} "      : "#{conditions} or #{fact_conditions} ")      unless ufs.empty?
+      conditions.sub!(/\s*\(\)\s*/, "")
+      conditions.sub!(/^(?:\(\))?\s?(?:and|or)\s*/, "")
+      conditions.sub!(/\(\s*(?:or|and)\s*\(/, "((")
+    end
+    {:conditions => conditions}
+  }
+
   # audit the changes to this model
   acts_as_audited :except => [:last_report, :puppet_status, :last_compile]
 
@@ -70,10 +99,10 @@ class Host < Puppet::Rails::Host
     validates_format_of      :sp_name, :with => /.*-sp/, :allow_nil => true, :allow_blank => true
     validates_presence_of    :architecture_id, :domain_id, :mac, :operatingsystem_id
     validates_length_of      :root_pass, :minimum => 8,:too_short => 'should be 8 characters or more'
-    validates_format_of      :mac,       :with => /([a-f0-9]{1,2}:){5}[a-f0-9]{1,2}/
-    validates_format_of      :ip,        :with => /(\d{1,3}\.){3}\d{1,3}/
+    validates_format_of      :mac,       :with => (/([a-f0-9]{1,2}:){5}[a-f0-9]{1,2}/)
+    validates_format_of      :ip,        :with => (/(\d{1,3}\.){3}\d{1,3}/)
     validates_presence_of    :ptable, :message => "cant be blank unless a custom partition has been defined",
-                             :if => Proc.new { |host| host.disk.empty? and not defined?(Rake) }
+      :if => Proc.new { |host| host.disk.empty? and not defined?(Rake) }
     validates_format_of      :sp_mac,    :with => /([a-f0-9]{1,2}:){5}[a-f0-9]{1,2}/, :allow_nil => true, :allow_blank => true
     validates_format_of      :sp_ip,     :with => /(\d{1,3}\.){3}\d{1,3}/, :allow_nil => true, :allow_blank => true
     validates_format_of      :serial,    :with => /[01],\d{3,}n\d/, :message => "should follow this format: 0,9600n8", :allow_blank => true, :allow_nil => true
@@ -103,8 +132,8 @@ class Host < Puppet::Rails::Host
   # supports a simple user, or a usergroup
   # selection parameter is expected to be an ActiveRecord id_and_type method (see Foreman's AR extentions).
   def is_owned_by=(selection)
-    oid = User.find(selection.to_i) if selection =~ /-Users$/
-    oid = Usergroup.find(selection.to_i) if selection =~ /-Usergroups$/
+    oid = User.find(selection.to_i) if selection =~ (/-Users$/)
+    oid = Usergroup.find(selection.to_i) if selection =~ (/-Usergroups$/)
     self.owner = oid
   end
 
@@ -193,11 +222,11 @@ class Host < Puppet::Rails::Host
 
   # returns the list of puppetclasses a host is in.
   def puppetclasses_names
-      return all_puppetclasses.collect {|c| c.name}
+    return all_puppetclasses.collect {|c| c.name}
   end
 
   def all_puppetclasses
-     return hostgroup.nil? ? puppetclasses : (hostgroup.puppetclasses + puppetclasses).uniq
+    return hostgroup.nil? ? puppetclasses : (hostgroup.puppetclasses + puppetclasses).uniq
   end
 
   # provide information about each node, mainly used for puppet external nodes
@@ -278,7 +307,7 @@ class Host < Puppet::Rails::Host
 
   def fv name
     v=fact_values.first(:select => "fact_values.value", :joins => :fact_name,
-                       :conditions => "fact_names.name = '#{name}'")
+                        :conditions => "fact_names.name = '#{name}'")
     v.value unless v.nil?
   end
 
@@ -404,9 +433,9 @@ class Host < Puppet::Rails::Host
   end
 
   def classes_from_storeconfigs
-   klasses = resources.find(:all, :conditions => {:restype => "Class"}, :select => :title, :order => :title)
-   klasses.map!(&:title).delete(:main)
-   return klasses
+    klasses = resources.find(:all, :conditions => {:restype => "Class"}, :select => :title, :order => :title)
+    klasses.map!(&:title).delete(:main)
+    return klasses
   end
 
   def can_be_build?
@@ -422,6 +451,28 @@ class Host < Puppet::Rails::Host
     return hash
   end
 
+  def enforce_permissions operation
+    if operation == "edit" and new_record?
+      return true # We get called again with the operation being set to create
+    end
+    current = User.current
+    if (operation == "edit") or operation == "destroy"
+      if current.allowed_to?("#{operation}_hosts".to_sym)
+        return true if Host.my_hosts(current).include? self
+      end
+    else # create
+      if current.allowed_to?(:create_hosts)
+        # We are unconstrained
+        return true if current.domains.empty? and current.hostgroups.empty?
+        # We are contrained and the constraint is matched
+        return true if (!current.domains.empty?    and current.domains.include?(domain)) or
+        (!current.hostgroups.empty? and current.hostgroups.include?(hostgroup))
+      end
+    end
+    errors.add_to_base "You do not have permission to #{operation} this host"
+    false
+  end
+
   private
   # align common mac and ip address input
   def normalize_addresses
@@ -459,5 +510,4 @@ class Host < Puppet::Rails::Host
     return if name.empty? or domain.nil?
     self.name += ".#{domain}" unless name =~ /.#{domain}$/
   end
-
 end
diff --git a/app/models/host_parameter.rb b/app/models/host_parameter.rb
index 932881d..7a6f883 100644
--- a/app/models/host_parameter.rb
+++ b/app/models/host_parameter.rb
@@ -3,7 +3,14 @@ class HostParameter < Parameter
   validates_uniqueness_of :name, :scope => :reference_id
 
   def to_s
-    "#{host_id ? host.name : "unassociated"}: #{name} = #{value}"
+    "#{host.id ? host.name : "unassociated"}: #{name} = #{value}"
   end
 
+  private
+  def enforce_permissions operation
+  # We get called again with the operation being set to create
+  return true if operation == "edit" and new_record?
+
+  self.host.enforce_permissions operation
+  end
 end
diff --git a/app/models/hostgroup.rb b/app/models/hostgroup.rb
index faf61a2..4557158 100644
--- a/app/models/hostgroup.rb
+++ b/app/models/hostgroup.rb
@@ -1,5 +1,7 @@
 class Hostgroup < ActiveRecord::Base
+  include Authorization
   has_and_belongs_to_many :puppetclasses
+  has_and_belongs_to_many :users, :join_table => "user_hostgroups"
   validates_uniqueness_of :name
   validates_format_of :name, :with => /\A(\S+\s?)+\Z/, :message => "can't be blank or contain trailing white spaces."
   has_many :group_parameters, :dependent => :destroy, :foreign_key => :reference_id
@@ -10,18 +12,17 @@ class Hostgroup < ActiveRecord::Base
 
   acts_as_audited
 
-#TODO: add a method that returns the valid os for a hostgroup
+  #TODO: add a method that returns the valid os for a hostgroup
 
- def all_puppetclasses
-   puppetclasses
- end
-
- def hostgroup
-   self
- end
+  def all_puppetclasses
+    puppetclasses
+  end
 
   def as_json(options={})
     super({:only => [:name, :id]}.merge(options))
   end
 
+  def hostgroup
+    self
+  end
 end
diff --git a/app/models/media.rb b/app/models/media.rb
index 95e3155..ec27953 100644
--- a/app/models/media.rb
+++ b/app/models/media.rb
@@ -1,4 +1,5 @@
 class Media < ActiveRecord::Base
+  include Authorization
   has_and_belongs_to_many :operatingsystems
   has_many :hosts
   validates_uniqueness_of :name
diff --git a/app/models/model.rb b/app/models/model.rb
index 75d414b..34e541e 100644
--- a/app/models/model.rb
+++ b/app/models/model.rb
@@ -1,4 +1,5 @@
 class Model < ActiveRecord::Base
+  include Authorization
   has_many :hosts
   before_destroy Ensure_not_used_by.new(:hosts)
   validates_uniqueness_of :name
diff --git a/app/models/notice.rb b/app/models/notice.rb
index 177a60a..dad6696 100644
--- a/app/models/notice.rb
+++ b/app/models/notice.rb
@@ -12,6 +12,14 @@ class Notice < ActiveRecord::Base
     "#{global? ? "global" : "individual"} #{content}"
   end
 
+  def destroy_notice
+    if global
+      destroy
+    else
+      users.delete(User.current)
+      destroy unless users.any?
+    end
+  end
   private
 
   def add_to_all_users
diff --git a/app/models/operatingsystem.rb b/app/models/operatingsystem.rb
index 21bded0..eb82383 100644
--- a/app/models/operatingsystem.rb
+++ b/app/models/operatingsystem.rb
@@ -2,6 +2,7 @@ require 'ostruct'
 require 'uri'
 
 class Operatingsystem < ActiveRecord::Base
+  include Authorization
   has_many :hosts
   has_and_belongs_to_many :medias
   has_and_belongs_to_many :ptables
diff --git a/app/models/parameter.rb b/app/models/parameter.rb
index cd5383a..7a8cc54 100644
--- a/app/models/parameter.rb
+++ b/app/models/parameter.rb
@@ -1,4 +1,5 @@
 class Parameter < ActiveRecord::Base
+  include Authorization
   acts_as_audited
   validates_presence_of   :name, :value
   validates_format_of     :name, :value, :with => /^.*\S$/, :message => "can't be blank or contain trailing white space"
diff --git a/app/models/ptable.rb b/app/models/ptable.rb
index 89084c6..34da00e 100644
--- a/app/models/ptable.rb
+++ b/app/models/ptable.rb
@@ -3,6 +3,7 @@
 # A host object may contain a reference to one of these ptables or, alternatively, it may contain a
 # modified version of one of these in textual form
 class Ptable < ActiveRecord::Base
+  include Authorization
   has_many :hosts
   has_and_belongs_to_many :operatingsystems
   before_destroy Ensure_not_used_by.new(:hosts)
diff --git a/app/models/puppetclass.rb b/app/models/puppetclass.rb
index 07a2e9f..f00ceb9 100644
--- a/app/models/puppetclass.rb
+++ b/app/models/puppetclass.rb
@@ -1,4 +1,5 @@
 class Puppetclass < ActiveRecord::Base
+  include Authorization
   has_and_belongs_to_many :environments
   has_and_belongs_to_many :operatingsystems
   has_and_belongs_to_many :hosts
diff --git a/app/models/report.rb b/app/models/report.rb
index d59f9ad..ff54b79 100644
--- a/app/models/report.rb
+++ b/app/models/report.rb
@@ -1,4 +1,5 @@
 class Report < ActiveRecord::Base
+  include Authorization
   belongs_to :host
   has_many :messages, :through => :logs, :dependent => :destroy
   has_many :sources, :through => :logs, :dependent => :destroy
@@ -244,12 +245,11 @@ class Report < ActiveRecord::Base
     nil
   end
 
-
   # The metrics layout has changed in Puppet 2.6.x release,
   # this method attempts to align the bit value metrics and the new name scheme in 2.6.x
   # returns a hash of { :type => "metric type", :name => "metric_name"}
   def self.translate_metrics_to26 metric
-   case metric
+    case metric
     when "applied"
       { :type => "changes", :name => :total}
     else
@@ -257,4 +257,15 @@ class Report < ActiveRecord::Base
     end
   end
 
+  def enforce_permissions operation
+    # No one can edit a report
+    return false if operation == "edit"
+
+    # Anyone can create a report
+    return true if operation == "create"
+    return true if operation == "destroy" and User.current.allowed_to?(:destroy_reports)
+
+    errors.add_to_base "You do not have permission to #{operation} this report"
+    false
+  end
 end
diff --git a/app/models/role.rb b/app/models/role.rb
new file mode 100644
index 0000000..9c96329
--- /dev/null
+++ b/app/models/role.rb
@@ -0,0 +1,154 @@
+# redMine - project management software
+# Copyright (C) 2006  Jean-Philippe Lang
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+class Role < ActiveRecord::Base
+  # Built-in roles
+  BUILTIN_DEFAULT_USER  = 1
+  BUILTIN_ANONYMOUS     = 2
+
+  named_scope :givable, { :conditions => "builtin = 0", :order => 'name' }
+  named_scope :builtin, lambda { |*args|
+    compare = 'not' if args.first == true
+    { :conditions => "#{compare} builtin = 0" }
+  }
+
+  before_destroy :check_deletable
+
+  has_many :user_roles, :dependent => :destroy
+  has_many :users, :through => :user_roles
+
+  serialize :permissions, Array
+  attr_protected :builtin
+
+  validates_presence_of :name
+  validates_uniqueness_of :name
+  validates_length_of :name, :maximum => 30
+  validates_format_of :name, :with => /^\w[\w\s\'\-]*\w$/i
+  validates_inclusion_of :builtin, :in => 0..2
+
+  def initialize *args
+    super *args
+    self.builtin = 0
+  end
+
+  def permissions
+    read_attribute(:permissions) || []
+  end
+
+  def permissions=(perms)
+    perms = perms.collect {|p| p.to_sym unless p.blank? }.compact.uniq if perms
+    write_attribute(:permissions, perms)
+  end
+
+  def add_permission!(*perms)
+    self.permissions = [] unless permissions.is_a?(Array)
+
+    permissions_will_change!
+    perms.each do |p|
+      p = p.to_sym
+      permissions << p unless permissions.include?(p)
+    end
+    save!
+  end
+
+  def remove_permission!(*perms)
+    return unless permissions.is_a?(Array)
+    permissions_will_change!
+    perms.each { |p| permissions.delete(p.to_sym) }
+    save!
+  end
+
+  # Returns true if the role has the given permission
+  def has_permission?(perm)
+    !permissions.nil? && permissions.include?(perm.to_sym)
+  end
+
+  # Return true if the role is a builtin role
+  def builtin?
+    self.builtin != 0
+  end
+
+  # Return true if the role is a user role
+  def user?
+    !self.builtin?
+  end
+
+  # Return true if role is allowed to do the specified action
+  # action can be:
+  # * a parameter-like Hash (eg. :controller => 'projects', :action => 'edit')
+  # * a permission Symbol (eg. :edit_project)
+  def allowed_to?(action)
+    if action.is_a? Hash
+      allowed_actions.include? "#{action[:controller]}/#{action[:action]}"
+    else
+      allowed_permissions.include? action
+    end
+  end
+
+  # Return all the permissions that can be given to the role
+  def setable_permissions
+    setable_permissions  = Foreman::AccessControl.permissions - Foreman::AccessControl.public_permissions
+    setable_permissions -= Foreman::AccessControl.loggedin_only_permissions if self.builtin == BUILTIN_ANONYMOUS
+    setable_permissions
+  end
+
+  # Find all the roles that can be given to a user
+  def self.find_all_givable
+    find(:all, :conditions => {:builtin => 0}, :order => 'name')
+  end
+
+  # Return the builtin 'default user' role.  If the role doesn't exist,
+  # it will be created on the fly.
+  def self.default_user
+    default_user_role = find(:first, :conditions => {:builtin => BUILTIN_DEFAULT_USER})
+    if default_user_role.nil?
+      default_user_role = create(:name => 'Default user') do |role|
+        role.builtin = BUILTIN_DEFAULT_USER
+      end
+      raise 'Unable to create the default user role.' if default_user_role.new_record?
+    end
+    default_user_role
+  end
+
+  # Return the builtin 'anonymous' role.  If the role doesn't exist,
+  # it will be created on the fly.
+  def self.anonymous
+    anonymous_role = find(:first, :conditions => {:builtin => BUILTIN_ANONYMOUS})
+    if anonymous_role.nil?
+      anonymous_role = create(:name => 'Anonymous') do |role|
+        role.builtin = BUILTIN_ANONYMOUS
+      end
+      raise "Unable to create the anonymous role." if anonymous_role.new_record?
+    end
+    anonymous_role
+  end
+
+private
+  def allowed_permissions
+    @allowed_permissions ||= permissions + Foreman::AccessControl.public_permissions.collect {|p| p.name}
+  end
+
+  def allowed_actions
+    @actions_allowed ||= allowed_permissions.inject([]) { |actions, permission| actions += Foreman::AccessControl.allowed_actions(permission) }.flatten
+  end
+
+  def check_deletable
+    errors.add_to_base "Role is in use" if users.any?
+    errors.add_to_base "Can't delete builtin role" if builtin?
+    errors.empty?
+  end
+end
diff --git a/app/models/subnet.rb b/app/models/subnet.rb
index 181121b..6f122ab 100644
--- a/app/models/subnet.rb
+++ b/app/models/subnet.rb
@@ -1,6 +1,7 @@
 class Subnet < ActiveRecord::Base
+  include Authorization
   has_many :hosts, :through => :domain
-  has_many :sps, :through => :hosts
+  #has_many :sps, :through => :hosts
   belongs_to :domain
   validates_presence_of   :number, :mask
   validates_uniqueness_of :number
@@ -9,7 +10,7 @@ class Subnet < ActiveRecord::Base
   validates_uniqueness_of :name, :scope => :domain_id
   validates_associated :domain
 
-  before_destroy Ensure_not_used_by.new(:hosts, :sps)
+  before_destroy Ensure_not_used_by.new(:hosts) #, :sps)
 
   # Subnets are displayed in the form of their network number/network mask
   def to_label
diff --git a/app/models/user.rb b/app/models/user.rb
index 64becfd..594c017 100644
--- a/app/models/user.rb
+++ b/app/models/user.rb
@@ -1,6 +1,7 @@
 require 'digest/sha1'
 
 class User < ActiveRecord::Base
+  include Authorization
   attr_protected :password_hash, :password_salt, :admin
   attr_accessor :password, :password_confirmation
 
@@ -9,6 +10,14 @@ class User < ActiveRecord::Base
   has_many :usergroups, :through => :usergroup_member
   has_many :direct_hosts, :as => :owner, :class_name => "Host"
   has_and_belongs_to_many :notices, :join_table => 'user_notices'
+  has_many :user_roles
+  has_many :roles, :through => :user_roles
+  has_and_belongs_to_many :domains,    :join_table => "user_domains"
+  has_and_belongs_to_many :hostgroups, :join_table => "user_hostgroups"
+  has_many :user_facts, :dependent => :destroy
+  has_many :facts, :through => :user_facts, :source => :fact_name
+
+  accepts_nested_attributes_for :user_facts, :reject_if => lambda { |a| a[:criteria].blank? }, :allow_destroy => true
 
   validates_uniqueness_of :login, :message => "already exists"
   validates_presence_of :login, :mail, :auth_source_id
@@ -24,6 +33,9 @@ class User < ActiveRecord::Base
   before_destroy Ensure_not_used_by.new(:hosts), :ensure_admin_is_not_deleted
   validate :name_used_in_a_usergroup
   before_validation :prepare_password
+  after_destroy Proc.new {|user| user.domains.clear; user.hostgroups.clear}
+
+  cattr_accessor :current
 
   def to_label
     "#{firstname} #{lastname}"
@@ -31,7 +43,7 @@ class User < ActiveRecord::Base
   alias_method :name, :to_label
 
   def <=>(other)
-    self.name <=> other.name
+    self.name.downcase <=> other.name.downcase
   end
 
   # The text item to see in a select dropdown menu
@@ -42,35 +54,48 @@ class User < ActiveRecord::Base
   def self.create_admin
     email = SETTINGS[:administrator] || "root@" + Facter.domain
     user = User.create(:login => "admin", :firstname => "Admin", :lastname => "User",
-                :mail => email, :auth_source => AuthSourceInternal.first, :password => "changeme")
+                       :mail => email, :auth_source => AuthSourceInternal.first, :password => "changeme")
     user.update_attribute :admin, true
     user
   end
 
+  # Tries to find the user in the DB and then authenticate against their authentication source
+  # If the user is not in the DB then try to login the user on each available athentication source
+  # If this succeeds then copy the user's details from the authentication source into the User table
+  # Returns : User object OR nil
   def self.try_to_login(login, password)
     # Make sure no one can sign in with an empty password
     return nil if password.to_s.empty?
-    if user = find(:first, :conditions => ["login=?", login])
+
+    if user = find_by_login(login)
       # user is already in local database
-      if user.auth_source
-        # user has an authentication method
-        return nil unless user.auth_source.authenticate(login, password)
+      if user.auth_source and user.auth_source.authenticate(login, password)
+        # user has an authentication method and the authentication was successful
+        User.current = user
+        user.update_attribute(:last_login_on, Time.now.utc)
+      else
+        user = nil
       end
     else
       # user is not yet registered, try to authenticate with available sources
       attrs = AuthSource.authenticate(login, password)
       if attrs
         user = new(*attrs)
+        # The default user must be given :create_users permissions for on-the-fly to work.
         user.login = login
+        User.current = user
         if user.save
           user.reload
           logger.info "User '#{user.login}' auto-created from #{user.auth_source}"
+          user.update_attribute(:last_login_on, Time.now.utc)
         else
           logger.info "Failed to save User '#{user.login}' #{user.errors.full_messages}"
+          user = nil
         end
       end
     end
-    user.update_attribute(:last_login_on, Time.now.utc) if user and not user.new_record?
+    anonymous = Role.find_by_name("Anonymous")
+    User.current.roles <<  anonymous unless user.nil? or User.current.roles.include?(anonymous)
     return user
   rescue => text
     raise text
@@ -80,12 +105,16 @@ class User < ActiveRecord::Base
     self.password_hash == encrypt_password(pass)
   end
 
-  def indirect_hosts
+  def my_usergroups
     all_groups = []
     for usergroup in usergroups
       all_groups += usergroup.all_usergroups
     end
-    all_groups.uniq.map{|g| g.hosts}.flatten.uniq
+    all_groups.uniq
+  end
+
+  def indirect_hosts
+    my_usergroups.map{|g| g.hosts}.flatten.uniq
   end
 
   def hosts
@@ -100,6 +129,30 @@ class User < ActiveRecord::Base
     auth_source and auth_source.can_set_password?
   end
 
+  # Return true if the user is allowed to do the specified action
+  # action can be:
+  # * a parameter-like Hash (eg. :controller => 'projects', :action => 'edit')
+  # * a permission Symbol (eg. :edit_project)
+  def allowed_to?(action, options={})
+    return true if admin?
+
+    return false if roles.empty?
+    roles.detect {|role| role.allowed_to?(action)}
+  end
+
+  def logged?
+    true
+  end
+
+  # Indicates whether the user has host filtering enabled
+  # Returns : Boolean
+  def filtering?
+    filter_on_owner or
+    domains.any?    or
+    hostgroups.any? or
+    facts.any?
+  end
+
   private
 
   def prepare_password
@@ -113,6 +166,8 @@ class User < ActiveRecord::Base
     Digest::SHA1.hexdigest([pass, password_salt].join)
   end
 
+  protected
+
   def name_used_in_a_usergroup
     if Usergroup.all.map(&:name).include?(self.login)
       errors.add_to_base "A usergroup already exists with this name"
@@ -124,8 +179,8 @@ class User < ActiveRecord::Base
   # admin account automatically
   def ensure_admin_is_not_deleted
     if login == "admin"
-      errors.add_to_base "Can't Delete Internal Admin account"
-      logger.warn "Unable to delete Internal Admin Account"
+      errors.add_to_base "Can't delete internal admin account"
+      logger.warn "Unable to delete internal admin account"
       return false
     end
   end
diff --git a/app/models/user_fact.rb b/app/models/user_fact.rb
new file mode 100644
index 0000000..8291c3a
--- /dev/null
+++ b/app/models/user_fact.rb
@@ -0,0 +1,22 @@
+class UserFact < ActiveRecord::Base
+  belongs_to :user
+  belongs_to :fact_name, :class_name => "Puppet::Rails::FactName"
+
+  validates_inclusion_of :andor,    :in => %w{and or}
+  validates_inclusion_of :operator, :in => %w{= !=  > >= < <= }
+  validates_presence_of  :fact_name
+  validates_presence_of  :criteria
+  validates_presence_of  :user
+
+  def initialize *args
+    super *args
+    operator = "="  if operator.empty?
+    andor    = "or" if andor.empty?
+  end
+
+  def to_s
+    n  = user.try(:name) || "Unknown user"
+    fn = fact_name.try(:name) || "Unknown fact"
+    "#{n}:#{fn}:#{criteria.empty? ? "Empty" : criteria}:#{operator}:#{andor}"
+  end
+end
diff --git a/app/models/user_role.rb b/app/models/user_role.rb
new file mode 100644
index 0000000..a66f652
--- /dev/null
+++ b/app/models/user_role.rb
@@ -0,0 +1,30 @@
+# Redmine - project management software
+# Copyright (C) 2006-2009  Jean-Philippe Lang
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+class UserRole < ActiveRecord::Base
+  belongs_to :user
+  belongs_to :role
+
+  validates_presence_of :role
+  validates_presence_of :user
+
+  def inherited?
+    !inherited_from.nil?
+  end
+
+  private
+end
diff --git a/app/models/usergroup.rb b/app/models/usergroup.rb
index cba8a0c..641d0b3 100644
--- a/app/models/usergroup.rb
+++ b/app/models/usergroup.rb
@@ -1,4 +1,5 @@
 class Usergroup < ActiveRecord::Base
+  include Authorization
   has_many_polymorphs :members, :from => [:usergroups, :users ], :as => :member,
     :through => :usergroup_member, :foreign_key => :usergroup_id, :dependent => :destroy
 
@@ -9,11 +10,6 @@ class Usergroup < ActiveRecord::Base
   # The text item to see in a select dropdown menu
   alias_attribute :select_title, :to_s
 
-  # Support for sorting the groups by name
-  def <=>(other)
-    self.name <=> other.name
-  end
-
   # This methods retrieves all user addresses in a usergroup
   # Returns: Array of strings representing the user's email addresses
   def recipients
@@ -28,7 +24,7 @@ class Usergroup < ActiveRecord::Base
   end
 
   # This methods retrieves all usergroups in a usergroup
-  # Returns: Array of usergroups
+  # Returns: Array of unique usergroups
   def all_usergroups(group_list=[self], user_list=[])
     retrieve_users_and_groups group_list, user_list
     group_list.sort.uniq
diff --git a/app/views/architectures/_form.html.erb b/app/views/architectures/_form.html.erb
index a47567d..9fe9912 100644
--- a/app/views/architectures/_form.html.erb
+++ b/app/views/architectures/_form.html.erb
@@ -5,8 +5,8 @@
   <%= f.text_field :name %>
   </p>
   <p>
-  <%= edit_habtm @architecture, Operatingsystem %>
+  <%= authorized_edit_habtm @architecture, Operatingsystem %>
   </p>
-
-  <p><%= f.submit "Submit" %></p>
+  <br/>
+  <%= f.submit "Submit" %>
 <% end %>
diff --git a/app/views/architectures/index.html.erb b/app/views/architectures/index.html.erb
index 03e52fe..4644244 100644
--- a/app/views/architectures/index.html.erb
+++ b/app/views/architectures/index.html.erb
@@ -8,10 +8,10 @@
   </tr>
   <% for architecture in @architectures %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%= link_to h(architecture.name), edit_architecture_path(architecture) %></td>
+      <td><%= link_to_if_authorized(h(architecture.name), hash_for_edit_architecture_path(:id => architecture.id)) %></td>
       <td><%=h architecture.operatingsystems.to_sentence %></td>
-      <td anign="right">
-        <%= link_to "Destroy", architecture, :confirm => "Delete #{architecture.name}?", :method => :delete %>
+      <td align="right">
+        <%= display_link_if_authorized "Destroy", hash_for_architecture_path(:id => architecture.id, :auth_action => :destroy), :confirm => "Delete #{architecture.name}?", :method => :delete  %>
       </td>
     </tr>
   <% end %>
@@ -19,4 +19,4 @@
 <%= page_entries_info @architectures %>
 <%= will_paginate @architectures %>
 
-<p><%= link_to "New Architecture", new_architecture_path %></p>
+<p><%= display_link_if_authorized "New Architecture", hash_for_new_architecture_path%></p>
diff --git a/app/views/auth_source_ldaps/index.html.erb b/app/views/auth_source_ldaps/index.html.erb
index 0f4584b..5288401 100644
--- a/app/views/auth_source_ldaps/index.html.erb
+++ b/app/views/auth_source_ldaps/index.html.erb
@@ -10,13 +10,13 @@
   </tr>
   <% for auth_source_ldap in @auth_source_ldaps %>
     <tr class="<%= cycle("even", "odd") -%>">
-      <td><%=link_to h(auth_source_ldap.name), edit_auth_source_ldap_path(auth_source_ldap) %></td>
+      <td><%=link_to_if_authorized h(auth_source_ldap.name), hash_for_edit_auth_source_ldap_path(:id => auth_source_ldap.id) %></td>
       <td><%=h auth_source_ldap.host %></td>
       <td><%=h auth_source_ldap.onthefly_register %></td>
       <td><%=h auth_source_ldap.tls %></td>
-      <td><%= link_to "Destroy", auth_source_ldap, :confirm => 'Are you sure?', :method => :delete %></td>
+      <td><%= display_link_if_authorized "Destroy", hash_for_auth_source_ldap_path(:id => auth_source_ldap, :auth_action => :destroy), :confirm => "Delete #{auth_source_ldap.name}?", :method => :delete %></td>
     </tr>
   <% end %>
 </table>
 
-<p><%= link_to "New Ldap Source", new_auth_source_ldap_path %></p>
+<p><%= display_link_if_authorized "New Ldap Source", hash_for_new_auth_source_ldap_path %></p>
diff --git a/app/views/common/403.rhtml b/app/views/common/403.rhtml
new file mode 100644
index 0000000..2b689be
--- /dev/null
+++ b/app/views/common/403.rhtml
@@ -0,0 +1,5 @@
+<h2>Permission denied</h2>
+
+<p>You are not authorised to perform this action</p>
+<p>Please request the required privileges from a foreman administrator</p>
+<p><%= link_to hosts_url -%></p>
